/// $Id: cpss.cpp,v 1.2 2002/11/19 14:03:36 halts Exp $
/**
 * cpss - P-Study System for Console Environments / Compact Pss
 *
 * @author Halts.
 *
 * preparation for database.pssdb4 in EUC Env.							\n
 *  > nkf -e database.pssdb4 > database-euc0.pssdb4						\n
 *  > perl -pe 's/\r\n/\n/g' database-euc0.pssdb4 > database-euc.pssdb4
 *
 */
#include "../common/pdb.h"
#include <ctime>
#include <clocale>
#include <algorithm>
#include "cpssintl.h"
#ifdef	WIN32_VC
# include "../../hcom/hreg.h"
#endif

//----- global variables

const char* g_szVer = PACKAGE_VERSION;				///< o[W

//----- implementations

/// c[Px\EINX
class ConsoleTreeSelector
{
public:
	//----- variables
	pdb::Tree*	pdb_;						///< f[^x[Xւ̃|C^
	pdb::String	strFolderPath_;				///< ݕ\ĂtH_
	// ͌ʁistrFolderPath_ + '/' + .. ŊSȃpXɂȂj
	pdb::Strings	straFolders_;			///< tH_Xg
	pdb::Strings	straSections_;			///< WXg

public:
	//----- methods
	/// RXgN^
	ConsoleTreeSelector( pdb::Tree* a_pdb ) : pdb_(a_pdb) {}

	/// 
	bool parse( const pdb::String& a_strFolderPath )
	{
		strFolderPath_ = a_strFolderPath;

		// ȇI
		pdb::Folder* parent = NULL;
		if( a_strFolderPath.empty()==false ) {
			try{
				parent = &pdb_->getFolder( a_strFolderPath );
			}catch( ... ){
			}
		}
		if( parent == NULL )
			parent = pdb_;

		// tH_̉
		straFolders_.clear();
		try{
			pdb::Folder* f;
			for( int i=0; i<26; i++ ) {
				f = &parent->getFolder( i );
				straFolders_.push_back( f->getName() );
			}
		}catch(...){
			// I
		}
		std::sort( straFolders_.begin(), straFolders_.end() );

		// ZNV̉
		straSections_.clear();
		try{
			pdb::Section* sec;
			for( int i=0; i<100; i++ ) {
				sec = &parent->getSection( i );
				straSections_.push_back( sec->getName() );
			}
		}catch(...){
			// I
		}
		std::sort( straSections_.begin(), straSections_.end() );

		return true;
	}

	/**
	 * \
	 *
	 * A-Z ŃtH_A0-100 ŖW\B
	 */
	bool view()
	{
		printf( "--- %s ---\n", strFolderPath_.empty() ? "Root" : strFolderPath_.c_str() );
		for( u_int i=0; i<straFolders_.size(); i++ ) {
			printf( " [%c] : %s\n", 'A'+i, straFolders_[i].c_str() );
		}
		for( u_int i=0; i<straSections_.size(); i++ ) {
			printf( " [%d] : %s\n", i, straSections_[i].c_str() );
		}
		return true;
	}

	/**
	 * I
	 *
	 * tpXԂB
	 */
	pdb::String select( const char* str_ )
	{
		pdb::String path = strFolderPath_;
		if( path.empty() == false ) {
			// [głȂ '/' ǉ
			path += "/";
		}
		char c = str_[0];
		if( isalpha(c) ) {
			// tH_
			int idx = isupper(c) ? c-'A' : c-'a';
			if( idx<0 || idx>=(int)straFolders_.size() )
				return "";

			path += straFolders_[idx];
		}else{
			// ZNV
			int idx = atoi(str_);
			if( idx<0 || idx>=(int)straSections_.size() )
				return "";

			path += straSections_[idx];
		}
		return path;
	}

};

/// ͑҂
int WaitEnter()
{
	printf(_("Enter > ") );
	return getchar();
}

/**
 * 񓚏̊ǗNX
 */ 
class ReplyManager
{
public:
	//--- variables
	const pdb::Section& sec_;					///< ZNVւ̃|C^
	int nCorrects_, nMistakes_;					///< ݂̉񓚂ł̐𐔁As
	int nCorrectsFirst_, nMistakesFirst_;		///< ̉񓚂ł̐𐔁As
	int nCorrectsTotal_, nMistakesTotal_;		///< ݐϐ𐔁As

public:
	//--- methods
	/// RXgN^
	ReplyManager( const pdb::Section* a_psec ) :
	    nMistakes_( 0 )
	   ,nCorrects_( 0 )
	   ,nMistakesFirst_( 0 )
	   ,nCorrectsFirst_( 0 )
	   ,nMistakesTotal_( 0 )
	   ,nCorrectsTotal_( 0 )
	   ,sec_( *a_psec )
	{
	}

	/// 񓚏
	bool DoReply() {
		//--- W̕\
		printf(_("--- Section Info. ---\n") );
		printf(_(" Name : \"%s\"\n"), sec_.getName().c_str() );
		printf(_(" Number of Questions : %d\n"), sec_.nQuestionLines() );
		printf(_(" Author : %s\n"), sec_.getAttributes().getAuthor() );
		printf(_(" Writer : %s\n"), sec_.getAttributes().getWriter() );
		printf( "---\n" );

		//--- 񓚉񐔂̎擾
		int nReply = InputNumberOfReply();
		if( nReply < 0 ) {
			return false;
		}

		//--- ۂ̉񓚏
		return ReplySection( nReply );
	}

private:
	/**
	 * 񓚉񐔂̓͏
	 *
	 * @return 񓚉񐔂ԂBG[ -1 ԂB
	 */
	int InputNumberOfReply()
	{
		if( sec_.nQuestionLines() == 0 ) {
			return -1;
		}
		int nQuestions = sec_.nQuestionLines();
		printf(_("Number of reply? (1-%d) [%d] > "), nQuestions, std::min<int>(10, nQuestions) );

		// obt@̊m
		std::vector<char> buf( 1024 );

		// ͑҂
		if( HFGets( &buf[0], 1024, stdin ) == NULL ) {
			return -1;
		}
		int nReply = 0;
		if( buf[0] == '\0' ) {
			// ftHg
			nReply = std::min<int>(10,nQuestions);
		}else{
			// I
			if( sscanf( &buf[0], "%d", &nReply ) != 1 ) {
				return -1;
			}
			if( nReply < 0 || nReply > sec_.nQuestionLines() ) {
				// out of range of reply-num. 
				return -1;
			}
		}

		// mF
		printf(_("%d ok? ([y]/n) > "), nReply );
		if( HFGets( &buf[0], 1024, stdin ) == NULL ) {
			return -1;
		}
		if( buf[0] == '\0' ) {
			// ftHg
		}else{
			if( buf[0] != 'y' && buf[0] != 'Y' ) {
				return -1;
			}
		}
		return nReply;
	}

	/**
	 * ƍ
	 * 
	 * @param q_			f[^
	 * @param idxCorrect_	ς݂̖̃CfbNX
	 * @param szInput_		͕
	 * @return ͂̃CfbNX, s -1 ԂB
	 */
	int Compare( pdb::Question q_, const std::vector<int>& idxCorrect_, const char* szInput_ )
	{
		for( int i=0; i<q_.nAnswer(); i++ ) {
			if( std::find( idxCorrect_.begin(), idxCorrect_.end(), i ) != idxCorrect_.end() ) {
				// ɐς
				continue;
			}
			// ƍ
			if( q_.getAnswer(i) == szInput_ ){
				return i;
			}
		}
		return -1;
	}

	/**
	 * 񓚏󋵂\
	 */
	void ShowReplyInfo( int nReply_, int iReply_ )
	{
		printf(_("--- Reply Info. ---\n") );
		if( nCorrectsFirst_+nMistakesFirst_ != 0 ) {
			// ĉ񓚂Ȃ̂ŁA̕\ĂB
			printf(_(" Num. of Corrects (on First-Reply): %d\n"), nCorrectsFirst_ );
			printf(_(" Num. of Mistakes (on First-Reply): %d\n"), nMistakesFirst_ );
			int nAll = nCorrectsFirst_ + nMistakesFirst_;
			printf(_(" Correct Rate     (on First-Reply): %.2f %%\n"), nAll==0 ? 0.0 : double( nCorrectsFirst_ )/nAll*100.0 );
			// g[^\B
			printf(_(" Num. of Corrects (Total): %d\n"), nCorrectsTotal_ );
			printf(_(" Num. of Mistakes (Total): %d\n"), nMistakesTotal_ );
			nAll = nCorrectsTotal_ + nMistakesTotal_;
			printf(_(" Correct Rate     (Total): %.2f %%\n"), nAll==0 ? 0.0 : double( nCorrectsTotal_ )/nAll*100.0 );
		}
		printf(_(" Num. of Corrects : %d\n"), nCorrects_ );
		printf(_(" Num. of Mistakes : %d\n"), nMistakes_ );
		int nAll = nCorrects_ + nMistakes_;
		printf(_(" Correct Rate     : %.2f %%\n"), nAll==0 ? 0.0 : double( nCorrects_ )/nAll*100.0 );
		printf(_(" Num. of Remains  : %d\n"), nReply_ - iReply_ -1 );
		printf( "---\n" );
	}

	/**
	 * ē͏
	 */
	bool ReinputQuestion( pdb::Question& q_, std::vector< int > CorrectIdx_ )
	{
		std::vector<char> buf( 1024 );			// ̓obt@
		std::vector< int > IncorrectIndex;		// ̃CfbNXXg
		// ̖T
		for( int i=0; i<q_.nAnswer(); i++ ) {
			if( std::find( CorrectIdx_.begin(), CorrectIdx_.end(), i ) == CorrectIdx_.end() ) {
				// Ȃ̂ŁA񓚂B
				IncorrectIndex.push_back( i );
			}
		}
		if( IncorrectIndex.empty() ) {
			// ŝ͂Ȃ̂ɖ肪ȂiS␳ĵŁAG[
			fprintf( stderr, _(" Cannot find non-correct-question of the question...\n") );
			return false;
		}
		for( int i=0; ; ) {
			int idx = IncorrectIndex[i];
			printf(_("C.Answer >> %s\n"), q_.getAnswer( idx ).c_str() );
			printf(_("Re-Input >> ") );
			if( HFGets( &buf[0], 1024, stdin ) == NULL )
				return false;

			if( &buf[0] == q_.getAnswer(idx) ) {
				// 
				printf(_("ok.\n") );
				i++;
				if( i == IncorrectIndex.size() ){
					// SI
					break;
				}
                printf(_("but it has another mean.\n") );
			}else{
				// s
				printf(_("NG.\n") );
			}
		}
		return true;
	}

	/// ReplyQuestion ̕Ԃl
	enum enumReplyQuestion {
		REPLYQUESTION_CORRECT = 1,		///< S␳
		REPLYQUESTION_MISTAKE = 0,		///< s
		REPLYQUESTION_ERROR = -1,		///< G[
	};
	/**
	 * P̖ q_ ̉񓚏
	 *
	 * @return enumReplyQuestion ԂB
	 */
	enumReplyQuestion ReplyQuestion( pdb::Question& q_ )
	{
		//--- Kvȕϐ̐錾
		std::vector<int> CorrectIndex;					// ςݖ̃Xgi𓚂ւ̑Ήj
		std::vector<char> buf( 1024 );					// ̓obt@

		//--- 𓚂Sĉ񓚂邽߂̃[v
		for( ;; ) {
			//--- ͏
			if( HFGets( &buf[0], 1024, stdin ) == NULL )
				return REPLYQUESTION_ERROR;

			//--- ƍ
			int r = Compare( q_, CorrectIndex, &buf[0] );
			if( r != -1 ) {
				// 
				CorrectIndex.push_back( r );			// ςݖ胊Xgɒǉ
				if( CorrectIndex.size() == q_.nAnswer() ) {
					// S␳
					printf(_("Correct!\n") );

					// ̏
					nCorrects_ ++;
					nCorrectsTotal_ ++;
					return REPLYQUESTION_CORRECT;		// S␳ŏI
				}else{
					// ܂قɓB
					printf(_("Correct, but it has another mean.\n") );
					printf(_("Answer   >> ") );
				}                    
			}else{
				// s
				//--- ē͏
				printf(_("Mistake...\n") );
				if( ReinputQuestion( q_, CorrectIndex ) == false )
					return REPLYQUESTION_ERROR;			// G[

				// s𐔂Z
				nMistakes_ ++;	
				nMistakesTotal_ ++;
				break;
			}
		}
		// 񓚏I
		return REPLYQUESTION_MISTAKE;
	}

	/**
	 * Aĉ񓚂Ȃǂ̂P񕪂̉񓚏sB
	 * s̃CfbNX idxMiss_ ɕۑB
	 *
	 */
	bool ReplySection_OneTime( const pdb::QuestionIndex& idxReply_, pdb::QuestionIndex& idxMiss_ )
	{
		for( int iReply=0; iReply < idxReply_.size(); iReply ++ ) {
			ShowReplyInfo( idxReply_.size(), iReply );									// 񓚏󋵂\

			//--- ̗p
			int iCurrIdx = idxReply_.get( iReply );			// ݉񓚒̖̃CfbNX
			pdb::Question q = sec_.getQuestion( iCurrIdx );
	//		printf( "%4d: %s ->\n", iCurrIdx, szLine );

			//--- ̕\
	//		printf( "--- Reply! ---\n" );
			pdb::String str;
			for( int i=0; i<q.nQuestion(); i++ ) {
				str = q.getQuestion(i);
				q.expandMacro( str );
				printf( "Question >> %s\n", str.c_str() );
			}
			if( q.nHint() != 0 ) {
				printf( "Hint     >> %s\n", q.getHint(0).c_str() );
			}
			printf( "Answer   >> " );

			//--- ͏
			switch( ReplyQuestion( q ) ) {
			case REPLYQUESTION_CORRECT:
				// 
				break;
			case REPLYQUESTION_MISTAKE:
				// s
				idxMiss_.add( iCurrIdx );
				break;
			case REPLYQUESTION_ERROR:
			default:
				return false;
			}
		}
		return true;
	}

	/**
	 * ĉ񓚏
	 */
	bool ReReply( const pdb::QuestionIndex& idxMissFirst_, const char* titlemsg_ )
	{
		pdb::QuestionIndex idxReply;
		pdb::QuestionIndex idxMiss = idxMissFirst_;
		for( int i=0;;i++ ) {
			printf( "\n*** %s (%d) ***\n", titlemsg_, i+1 );
			idxReply = idxMiss;
			idxMiss.clear();
			nCorrects_ = nMistakes_ = 0;
			if( ReplySection_OneTime( idxReply, idxMiss ) == false )
				return false;			// G[
			if( idxMiss.size() == 0 ) {
				// S␳Ȃ̂ŏIB
				break;
			}
			// S␳ł͂Ȃ̂ŁAēx񓚏B
		}
		return true;
	}

	/// W̉񓚏
	bool ReplySection( int nReplyRequested_ )
	{
		//--- CfbNX̐
		// }X^[CfbNX
		pdb::QuestionIndex idxMaster;
		idxMaster.makeIndex( sec_ );
		// ̉񓚗pCfbNX
		pdb::QuestionIndex idxFirstReply = idxMaster;
		idxFirstReply.shuffle();
		idxFirstReply.index_.resize( nReplyRequested_ );
		// ̑̃CfbNX
		pdb::QuestionIndex idxMissFirst;					// ݂̉񓚂ŊԈႦQ

		//--- ̉
		printf(_("*** First Reply ***\n") );
		if( ReplySection_OneTime( idxFirstReply, idxMissFirst ) == false )
			return false;			// G[

		if( idxMissFirst.size() == 0 ) {
			// ĉ񓚂̕KvȂ
			printf(_("Great! You Answered All Questions!!\n") );
			return true;
		}

		//--- ĉ񓚁AāX񓚂̏
		nCorrectsFirst_ = nCorrects_;
		nMistakesFirst_ = nMistakes_;

		//--- ĉ񓚏
		if( ReReply( idxMissFirst, _("Mistake Reply[1/2]") ) == false )
			return false;		// G[

		//--- āX񓚏
		if( ReReply( idxMissFirst, _("Mistake Reply[2/2]") ) == false )
			return false;		// G[

		printf(_("End of Reply Operation.\n") );

		return true;
	}

};

/// show usage
void usage()
{
	printf(_("Usage: cpss [DatabaseFile]\n") );
}

/// C֐
int main( int argc, char** argv )
{
	// 
	if( argc > 2 ) {
		usage();
		return 0;
	}
	for( int i=1; i<argc; i++ ) {
		if( strcmp( argv[i], "-h" ) == 0 ||
			strcmp( argv[i], "--help" ) == 0 ) 
		{
			usage();
			return 0;
		}
	}

	// for NLS
	setlocale(LC_ALL, "");
	bindtextdomain(PACKAGE_NAME, PACKAGE_LOCALE_DIR);
	textdomain(PACKAGE_NAME);

	//--- f[^x[XpX̎擾
	pdb::String strDatabasePath
#ifdef DEFAULT_DATABASE
		= DEFAULT_DATABASE;
#else /* !DEFAULT_DATABASE */
		;
#endif /* !DEFAULT_DATABASE */

#ifndef	DEFAULT_DATABASE
#ifdef	WIN32_VC
	//--- Pss CXg[Ă΁AWXgf[^x[XpX擾B
	std::string strRegistryKey = "Software\\Halts Presents\\Pss";	// L[̍쐬
	hreg::setRegistryKey( strRegistryKey.c_str() );					// L[̎w
	// l̓
	if( hreg::getString( "DBv3", "filename", "", strDatabasePath ) == false ) {
		usage();
		return 0;
	}
#else
	if( argc < 2 ) {
		usage();
		return 0;
	}
#endif
#endif

	//--- ̎擾
	if (argc > 1)
		strDatabasePath = argv[1];			// f[^x[Xt@C̃pX


	//--- 
	// ̏
	srand( (u_int)time(NULL) );

	//--- DB ̃[h
	pdb::Tree		db;							///< f[^x[X
	if( db.readTree( strDatabasePath.c_str() ) == false ) {
		printf(_("cannot load db... (%s)\n"), strDatabasePath.c_str() );
		return -1;
	}

	//--- c[IIuWFNg̐ݒ
	ConsoleTreeSelector selector( &db );
	selector.parse( "" );		// 

	// obt@̊m
	std::vector<char> buf( 1024 );

	// o[W
	printf( "P-Study System for Console Environments / Compact Pss  Ver.%s\n"
			"Written by Halts\n"
			"\n"
			"Copyright (C) 2002 Halts.\n", g_szVer );
	// [v
	for( ;; ) {
		// c[ƃbZ[W̕\
		printf(_("\n<< Select Section or Folder >>\n"));
		selector.view();
		if( selector.strFolderPath_.empty() == false ) {
			printf(_(" [Return] : Back to up folder.\n") );
		}
		printf(_(" [Quit] : Terminate cpss.\n") );
		printf(_("Choose Section, Folder or Command > ") );

		// ͑҂
		if( HFGets( &buf[0], 1024, stdin ) == NULL ) {
			continue;
		}

		// Ɉړ
		if( buf[0] == '\0' ){
			pdb::String strFolder, strSection;
			if( pdb::Tree::splitPath2FolderSection( selector.strFolderPath_, strFolder, strSection ) ) {
				selector.parse( strFolder );
			}else{
				selector.parse( "" );
			}
			continue;
		}

		// Quit?
		pdb::String strBuf = &buf[0];
		HUpperString( &buf[0], strBuf );
		if( strBuf == "QUIT" ) {
			break;
		}

		// ZNVEtH_̑I
		pdb::String path = selector.select( &buf[0] );
		if( path.empty() )
			continue;
		if( db.hasFolder( path ) ) {
			// tH_
			// ItH_ɈڂB
			selector.parse( path );
		}else if( db.hasSection( path ) ) {
			// ZNV
			// Section ̎擾
			pdb::Section* psec = NULL;
			try{
				psec = &db.getSection( path );
			}catch( ... ){
				printf(_(" cannot get section...\n") );
				return false;
			}

			// 񓚏
			ReplyManager rm( psec );
			rm.DoReply();					// 񓚏ĂяoB

			WaitEnter();
		}
	}

	return 0;
}
