// $Id: hcom_win.h,v 1.1.1.1 2002/11/16 16:02:36 halts Exp $
/* HComLib - Halts Common Library 
 * Copyright (C) 2001 Halts (TAKEUCHI Hiroaki) .
 */

#ifndef ___HCOM_WIN_H_INCLUDED_
#define ___HCOM_WIN_H_INCLUDED_

#ifdef	WIN32

#pragma warning(disable: 4786)

//--------------------------------------------------------------------
//----- include header files

#include <windows.h>
#include <shlobj.h>
//#include <string>				///< use std::string
//#include <algorithm>			///< use algorithm
//#include <vector>

//----- RECT p}N
#define	RECT_W(r)	( (r).right - (r).left )
#define RECT_H(r)	( (r).bottom - (r).top )



//--------------------------------------------------------------------
//----- prototype-declarations

//--- VXen
void				HErrorMsgDlg( HWND hWnd, const char*msg, ... );
bool				HDataExecute( LPCTSTR lpszFileName );
BOOL				HExecute( LPTSTR lpCommandLine, LPCTSTR lpDirectory );
bool				HFileExecute( LPCTSTR lpszFileName );

bool				HGetModulePath( char *szBuf, int iBufLen );
inline	std::string	HGetModulePath();
bool				HAddStartMenu(const char *szCompanyName, const char *szProductName,
						const char *szShortcutName, const char *szProgramName, const char *szAttribute,
						const char *szArgument );

//--- tH_AfBNg֘A
bool				HCreateDirectoryDirect( const char *szNewDirectory );
bool				HMakeDir( char* pszDir );
bool				HMakeDirFull( char* pszDir );

bool				HGetSpecialFolderLocation( int nFolder, char* szPathArg );
int					HGetTempPath( char * szBuf, int nBufLen );
int					HGetProgramFilesPath( char * szBuf, int nBufLen );

//--- ̑̃t@C֘A
bool				HCreateLinkFile( LPCTSTR lpszShortcutFile,
						LPCTSTR lpszDescription,
						LPCTSTR lpszTargetFile,
						LPCTSTR lpszArguments );
bool				HCopyFile( char *szInfo1, char *szInfo2 );


//--- Window ֘A
LONG				HSetWindowStyle( HWND hWnd, LONG lStyle );
LONG				HResetWindowStyle( HWND hWnd, LONG lStyle );
bool				HDlgMoveWindow( HWND hDlg, int nItem, RECT * pRect );
bool				HOpenFileDialog( HWND hwnd, char *szFileName );

//--- `֘A
void				HTextOut( HDC hdc, int x, int y, const char *lpMsg, ... );

/// RECT ^\̂ x, y yё傫iwidth, heightjw肵Ēlݒ肷B
inline 	void		HSetRect( RECT &rect, int x, int y, int width, int height );

/// POINT ^\̂ x, y ݒ肷B
inline 	void		HSetPoint( POINT &pos, int x, int y );

//--- 񑀍֌W

int					HReplaceString( char *indata, char ch, const char *to );
int					HReplaceString( char *indata, const char* from, const char *to );
void				HMakeUpperString( char * upper, const char * src, int len );

inline	bool		HSPrintf( std::string& buf, const char* format, ... );	
inline	bool		HSPrintf( std::string& buf, const char* format, va_list marker );
																///< string ɑ΂ sprintf


//--- ̑
int					HGetRandom( int min, int max );
/**
 * SZ(+MOD)ŋLqꂽ str vZlԂB
 *
 * g鉉Zq́A+ - * / % ( ) ̂݁B
 * %  int ɃLXgꂽlvZB
 */
double HCalcString( std::string str );
/**
 *  str_  , ؂ŕAelements_ ɗ^B
 *
 * , ŕȂ̈iJnƏIj excepts Œ`łB
 * Ƃ "a, (b, c), 'ahi,ihi'"  "a", " (b, c)", " 'ahi,ihi'" ɕꍇ́A
 * excepts = "(),," ƂBexcepts ̋CfbNXJnACfbNXIB
 *
 * \param str_		[in]	, ؂̕
 * \param elements_ [out]	̕Q
 * \param excepts_	[in]	̈̒`
 */
bool HSplitComma( const std::string& str_, 
			std::vector< std::string >& elements_, 
			const std::string& excepts_ = "" );




//--------------------------------------------------------------------
//----- implementations for inline functions

inline	std::string	HGetModulePath()
{
	char* buf = new char[MAX_PATH];
	HGetModulePath( buf, MAX_PATH );
	std::string str = buf;
	delete[] buf;
	
	return str;
}

inline 	void		HSetRect( RECT &rect, int x, int y, int width, int height )
{
	rect.top	= y;
	rect.left	= x;
	rect.bottom = y + height;
	rect.right	= x + width;
}

inline 	void		HSetPoint( POINT &pos, int x, int y )
{
	pos.x = x;
	pos.y = y;
}

//--- Nbv{[h֘A

/// Nbv{[heLXg擾
//
/// @return G[ falseA true ԂB
//
inline bool HGetClipboardDataText( std::string& strText_ )
{
	if( IsClipboardFormatAvailable(CF_TEXT)==FALSE ){
		// AfxMessageBox("eLXgf[^͂܂B");
		return false;
	}
	
	if( !OpenClipboard(NULL) ) return false;
	
	HGLOBAL hGet = GetClipboardData( CF_TEXT );
	char* pPtr = (char *)GlobalLock( hGet );
	strText_ = pPtr;
	GlobalUnlock( hGet );
	
	CloseClipboard();
	
	return true;
}

/// Nbv{[hɃeLXgݒ
//
/// @return G[ falseA true ԂB
//
inline bool HSetClipboardDataText( const char* szText_ )
{
	if( !OpenClipboard(NULL) ) return false;
	
	HGLOBAL hMem = GlobalAlloc( GHND, strlen(szText_)+1 );
	char* pPtr = (char *)::GlobalLock( hMem );
	lstrcpy( pPtr, szText_ );
	GlobalUnlock( hMem );
	EmptyClipboard();
	
	HANDLE hRet = SetClipboardData( CF_TEXT, hMem );
	
	CloseClipboard();
	
	GlobalFree( hMem );
	
	return hRet == NULL ? false : true;
}

/// EBhE hwnd_ fXNgbvɑ΂ăZ^O
inline bool HCenteringDialog( HWND hwnd_, int w, int h )
{
	RECT rectParent;
	GetWindowRect( GetDesktopWindow(), &rectParent );
	MoveWindow( hwnd_,
		(RECT_W(rectParent)- w) /2,
		(RECT_H(rectParent)- h) /2,
		w,
		h, FALSE );
	return true;
}

/// Mutex ǗNX
class HMutex
{
	HANDLE	hMutex_;
	bool	bLock_;			// Lock ǂ
public:
	HMutex() : hMutex_(NULL), bLock_(false) {}
	~HMutex(){
		Unlock();
		Close();
	}
	bool Lock( const char* szInstance ){
		// I[v
		hMutex_ = OpenMutex( MUTEX_ALL_ACCESS, FALSE, szInstance );
		if( hMutex_ ){
			// I[vł̂ŁAbNς
			CloseHandle( hMutex_ );
			hMutex_ = NULL;
			return false;
		}
		// bN
		hMutex_ = CreateMutex( FALSE, 0, szInstance );
		if( hMutex_ == NULL ) return false;
		bLock_ = true;
		return true;
	}
	bool Unlock()
	{
		if( bLock_ ){
			if( ReleaseMutex( hMutex_ ) == NULL ){
				return false;
			}
			return true;
		}
		return false;
	}
	bool Close()
	{
		if( hMutex_ ){
			if( CloseHandle( hMutex_ ) == FALSE ){
				return false;
			}
			return true;
		}
		return false;
	}

};

/// pX̕
class HPathSplitter
{
public:
	//----- member vars.

	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];

	//----- methods

	HPathSplitter()
	{
		strcpy( drive, "" );
		strcpy( dir, "" );
		strcpy( fname, "" );
		strcpy( ext, "" );
	}

	HPathSplitter( const char* strPath_ ){
		HPathSplitter();

		split( strPath_ );
	}

	bool split( const char* strPath_ )
	{
		_splitpath( strPath_, drive, dir, fname, ext );
		return true;
	}

	std::string getFolderPath()
	{
		std::string strFolder = drive;
		strFolder += dir;

		if( strFolder.empty() )
			return strFolder="";

		if( strFolder.substr( strFolder.length()-1, 1 ) == "\\" ){
			strFolder.erase( strFolder.length()-1, 1 );
		}
		return strFolder;
	}
};

/// rbg}bv HDC ̊ǗNX
class HBitmapManager {
public:
	//----- Members
	HDC		hdc_;									///< Memory-DC (:NULL)
	HBITMAP	bmp_;									///< BITMAP (:NULL)
	int		nWidth_;								///< 
	int		nHeight_;								///< 
	//----- Methods
	HBitmapManager() : hdc_(NULL), bmp_(NULL), nWidth_(0), nHeight_(0) {}
													///< RXgN^
	~HBitmapManager() { clear(); }					///< fXgN^
	/// iʏ͌ĂяoKv͂Ȃj
	bool clear() {
		if( hdc_ ) {
			DeleteDC( hdc_ );
			hdc_ = NULL;
		}
		if( bmp_ ) {
			DeleteObject( bmp_ );
			bmp_ = NULL;
		}
		return true;
	}
	/// [h
	bool load( HINSTANCE hInst__, LPCTSTR filename__, HDC hdc__ ) {
		// 
		clear();
		// [h
		bmp_ = (HBITMAP)LoadImage( hInst__, filename__,
			IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION | LR_LOADFROMFILE );
		if( bmp_ ) {		// [hȂ
			hdc_ = ::CreateCompatibleDC( hdc__ );
			::SelectObject( hdc_, bmp_ );
			loadImageMetrics( filename__ );
			return true;
		}
		return false;
	}
private:
	/// Image ̏擾BiWidth-Heightj
	bool loadImageMetrics( LPCTSTR filename__ ) {
		HANDLE hF;
		HANDLE hMem1, hMem2;
		LPBITMAPFILEHEADER lpBf;
		LPBITMAPINFOHEADER lpBi;
		DWORD dwResult;

		hF = CreateFile(filename__, GENERIC_READ, 0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
		if (hF == INVALID_HANDLE_VALUE) {
			return false;
		}
		hMem1 = GlobalAlloc(GHND, sizeof(BITMAPFILEHEADER));
		lpBf = (LPBITMAPFILEHEADER)GlobalLock(hMem1);
		ReadFile(hF, (LPBITMAPFILEHEADER)lpBf, sizeof(BITMAPFILEHEADER), &dwResult, NULL);

		GlobalUnlock(hMem1);
		GlobalFree(hMem1);

		hMem2 = GlobalAlloc(GHND, sizeof(BITMAPINFOHEADER));
		lpBi = (LPBITMAPINFOHEADER)GlobalLock(hMem2);
		ReadFile(hF, (LPBITMAPINFOHEADER)lpBi, sizeof(BITMAPINFOHEADER), &dwResult, NULL);

		nWidth_ = lpBi->biWidth;
		nHeight_ = lpBi->biHeight;

		GlobalUnlock(hMem2);
		GlobalFree(hMem2);

		CloseHandle(hF);
		return true;
	}
};

/// string ɑ΂ sprintf 
//
/// @note WJ̕ 1024 ȉł邱ƁB
//
inline	bool		HSPrintf( std::string& a_buf, const char* a_format, ... )
{
	try{
		va_list marker;									// ό̈Xg
		va_start( marker, a_format );					// ό̈̏
		bool r = HSPrintf( a_buf, a_format, marker );	// tH[}bg̓WJ
		va_end( marker );								// ό̈̃Zbg
		return r;
	}
	catch( ... )
	{
		return false;
	}
}
inline	bool		HSPrintf( std::string& a_buf, const char* a_format, va_list a_marker )
{
	try{
		char* buf = new char[1024];
		vsprintf( buf, a_format, a_marker );	
		a_buf = buf;						// obt@Ɋi[
		delete[] buf;
	}
	catch( ... )
	{
		return false;
	}
	return true;
}


#endif	// WIN32
#endif	// ___HCOM_H_INCLUDED_
